import Image
from pandac.PandaModules import *

def hightprocess(h):
    if h < 80 : h  = 80
    return h*.1

class Map:

    def __init__(self,colorMap,heightMap,size=(150,150)):
        self.data = self.fromFile(heightMap,size)
        self.node = self.generate() # generate teh under side 
        tx = loader.loadTexture(colorMap)
        tx.setMinfilter(Texture.FTLinearMipmapLinear)
        self.node.setTexture(tx)        
        
    def fromFile(self,height,size=None): 
        hmap = Image.open(height).convert("L")
        if size != None:  
            size = size[1],size[0]
            hmap = hmap.resize(size, Image.ANTIALIAS)
        xs,ys = hmap.size
        hmap = hmap.resize((xs,ys), Image.ANTIALIAS)
        return  [[hightprocess(hmap.getpixel((x,ys-y-1))) for y in range(ys)] for x in range(xs)]
                 
             
    def generate(self):
        """ generate a terrain """
        def tp(n):
            list = [1,1,1,1]
            return list
        data = self.data
        vdata = GeomVertexData('terrain', GeomVertexFormat.getV3c4t2(), Geom.UHStatic)
        vertex = GeomVertexWriter(vdata, 'vertex')
        uv = GeomVertexWriter(vdata, 'texcoord')
        color = GeomVertexWriter(vdata, 'color')
        number = 0
        hm = 1
        xs = 1./len(data)
        ys = 1./len(data[0])
        for x in range(1,len(data)-1):
            for y in range(1,len(data[x])-1):
                v1 = Vec3(x,y,data[x][y])
                v2 = Vec3(x+1,y,data[x+1][y])
                v3 = Vec3(x+1,y+1,data[x+1][y+1])
                v4 = Vec3(x,y+1,data[x][y+1])
                                                     
                vertex.addData3f(v1)
                uv.addData2f(x*xs,y*ys)
                vertex.addData3f(v2)
                uv.addData2f((x+1)*xs,y*ys)               
                vertex.addData3f(v3)
                uv.addData2f((x+1)*xs,(y+1)*ys)
         
                vertex.addData3f(v1)
                uv.addData2f(x*xs,y*ys)
                vertex.addData3f(v3)
                uv.addData2f((x+1)*xs,(y+1)*ys)
                vertex.addData3f(v4)
                uv.addData2f(x*xs,(y+1)*ys)
                number = number + 2
                
        prim = GeomTriangles(Geom.UHStatic)
        for n in range(number):
            prim.addVertices(n*3,n*3+1,n*3+2)
        prim.closePrimitive()
        geom = Geom(vdata)
        geom.addPrimitive(prim)
        self.geomnode = GeomNode('gnode')
        self.geomnode.addGeom(geom)
        terain = NodePath("terrain")
        terain.attachNewNode(self.geomnode)
        #terain.reparentTo(render)
        #terain.setBin("",1)
        #terain.setPos(-len(data)/2,-len(data[0])/2,0)
        return terain
    
   
